package MIDICompose;

public class AfterTouch extends VoiceEvent implements Channelable, Amountable, Pitchable
{
	public static final int MIN = 0;
	public static final int MAX = 127;
	public static final int ZERO = 0;

	public AfterTouch(int pitch, int amount) { this(0, 0, pitch, amount); }
	public AfterTouch(int deltaTime, int channel, int pitch, int amount) {
		super(deltaTime, 0xa0, channel); setPitch(pitch); setAmount(amount); lock(); }

	public int pitch() { return dataValueAt(0); }
	public void setPitch(int pitch) { setDataValueAt(pitch,0); }

	public int amount() { return dataValueAt(1); }
	public void setAmount(int amount) { setDataValueAt(amount,1); }

	public int minAmount() { return MIN; }
	public int maxAmount() { return MAX; }
	public int zeroAmount() { return ZERO; }

	public MIDIObject copy() {
		return new AfterTouch(deltaTime(), channel(), pitch(), amount()); }
}

