package MIDICompose;

public class ChannelPressure extends VoiceEvent implements Channelable, Amountable
{
	public static final int MIN = 0;
	public static final int MAX = 127;
	public static final int ZERO = 0;

	public ChannelPressure(int amount) { this(0, 0, amount); }
	public ChannelPressure(int deltaTime, int channel, int amount) {
		super(deltaTime, 0xc0, channel); setAmount(amount); lock(); }

	public int amount() { return dataValueAt(0); }
	public void setAmount(int amount) { setDataValueAt(amount,0); }

	public int minAmount() { return MIN; }
	public int maxAmount() { return MAX; }
	public int zeroAmount() { return ZERO; }

	public MIDIObject copy() {
		return new ChannelPressure(deltaTime(), channel(), amount()); }
}

