package MIDICompose;

public class Ghost extends MIDIObject
	implements Channelable, Amountable, Lengthable, Pitchable
{
	private boolean editable;		// true: this can be edited (changes original!)

	public Ghost(MIDIObject object) { this(0, false, object); }
	public Ghost(int deltaTime, boolean editable, MIDIObject object) {
		super(deltaTime); add(object); setEditable(editable); lock(); }

	public boolean editable() { return editable; }
	public void setEditable(boolean editable) { this.editable = editable; }

	// all following set-methods only are setting, if editable is true.

//************************************* Channelable **************************************

	public int channel() {
		if(elementAt(0) instanceof Channelable)
			return ((Channelable)elementAt(0)).channel();
		else return -1; }
	public void setChannel(int channel) {
		if(editable && (elementAt(0) instanceof Channelable))
			((Channelable)elementAt(0)).setChannel(channel); }

//************************************** Pitchable ***************************************

	public int pitch() {
		if(elementAt(0) instanceof Pitchable)
			return ((Pitchable)elementAt(0)).pitch();
		else return 0; }
	public void setPitch(int pitch) {
		if(editable && (elementAt(0) instanceof Pitchable))
			((Pitchable)elementAt(0)).setPitch(pitch); }

//************************************** Lengthable **************************************

	public int length() {
		if(elementAt(0) instanceof Lengthable)
			return ((Lengthable)elementAt(0)).length();
		else return 0; }
	public void setLength(int length) {
		if(editable && (elementAt(0) instanceof Lengthable))
			((Lengthable)elementAt(0)).setLength(length); }
	public void turnRound() {
		if(editable && (elementAt(0) instanceof Lengthable))
			((Lengthable)elementAt(0)).turnRound(); }

//************************************** Amountable **************************************

	public int amount() {
		if(elementAt(0) instanceof Amountable)
			return ((Amountable)elementAt(0)).amount();
		else return 0; }
	public void setAmount(int amount) {
		if(editable && (elementAt(0) instanceof Amountable))
			((Amountable)elementAt(0)).setAmount(amount); }

	public int minAmount() {
		if(elementAt(0) instanceof Amountable)
			return ((Amountable)elementAt(0)).minAmount();
		else return 0; }
	public int maxAmount() {
		if(elementAt(0) instanceof Amountable)
			return ((Amountable)elementAt(0)).maxAmount();
		else return 0; }
	public int zeroAmount() {
		if(elementAt(0) instanceof Amountable)
			return ((Amountable)elementAt(0)).zeroAmount();
		else return 0; }

	public MIDIObject copy() { return new Ghost(deltaTime(), editable(), elementAt(0)); }
}