package MIDICompose;

import java.util.*;
import java.io.*;

public abstract class MIDIObject							// basis-class for all complexer classes
{
	private int deltaTime;											// relative start position in ticks
	private Vector vector;											// vector for MIDIObjects
	private boolean locked;											// if true: no more MIDIObjects can be added

	protected MIDIObject(int deltaTime) {
		super();
		setDeltaTime(deltaTime);
		locked = false;
		vector = new Vector(); }

	public int deltaTime() { return deltaTime; }
	public void setDeltaTime(int deltaTime) {
		if(deltaTime < 0) {
			System.out.println("ERROR: negative deltaTime."); System.exit(-1); }
		this.deltaTime = deltaTime; }

	public void lock() { locked = true; }						// all add() after lock() are ignored
	public boolean locked() { return locked; }			// returns true if this is locked
	protected void add(MIDIObject object) {					// adds a new MIDIObject to instance
		if(!locked && !(object instanceof MIDIFile)) vector.addElement(object); }

	protected int size() { return vector.size(); }	// number of objects stored in instance
	protected MIDIObject elementAt(int index) {			// MIDIObject with index in this intance
		if((index < 0) || (index >= size())) {
			System.out.println("ERROR: element-index out of range."); System.exit(-1); }
		return (MIDIObject)(vector.elementAt(index)); }

	protected void turnRound() {                		// position of elements turned round.
		Vector vector = new Vector();
		for(int i = size()-1; i >= 0; i--) vector.addElement(elementAt(i));
		this.vector = vector; }

	abstract public MIDIObject copy();			  			// returns a copy of this
}
