package MIDICompose;

public interface MIDIVariables								// variables for MIDI-values
{
	public static final int OCTAVE = 12;				// c#3 can be written as C+SHARP+OCTAVE*5
	public static final int SEVENTH = 11;
	public static final int SIXTH = 9;
	public static final int FIFTH = 7;
	public static final int FOURTH = 5;
	public static final int THIRD = 4;
	public static final int SECOND = 2;
	public static final int FLAT = -1;
	public static final int SHARP = 1;

	public static final int C = 0;
	public static final int D = 2;
	public static final int E = 4;
	public static final int F = 5;
	public static final int G = 7;
	public static final int A = 9;
	public static final int B = 11;
	public static final int H = 11;

	public static final int QUARTER = 384;			// timing values
	public static final int WHOLE = QUARTER * 4;
	public static final int HALF = QUARTER * 2;
	public static final int EIGHTH = QUARTER / 2;
	public static final int SIXTEENTH = QUARTER / 4;
	public static final int START = 0;

	public static final double SLOWLY = 70.0;
	public static final double MODERATELY = 120.0;
	public static final double FAST = 180.0;

	public static final int SOFT = 35;					// amount values
	public static final int MEDIUM = 70;
	public static final int HARD = 105;
	public static final int MIN = 0;
	public static final int MAX = 127;

	public static final int ON = 127;						// controller on/off
	public static final int OFF = 0;

	public static final boolean ENABLE = true;
	public static final boolean DISABLE = false;

	public static final int BANK_SELECT = 0;			// some controllers
	public static final int MODULATION = 1;
	public static final int BREATH = 2;
	public static final int FOOT_PEDAL = 3;
	public static final int VOLUME = 7;
	public static final int BALANCE = 8;
	public static final int PAN = 10;
	public static final int EXPRESSION = 11;
	public static final int EFFECT1 = 12;
	public static final int EFFECT2 = 13;
	public static final int HOLD_PEDAL = 64;
	public static final int EFFECTS_LEVEL = 91;
	public static final int CHORUS_LEVEL = 93;
	public static final int PHASER_LEVEL = 95;

	public static final int CHAN_1 = 0;
	public static final int CHAN_2 = 1;
	public static final int CHAN_3 = 2;
	public static final int CHAN_4 = 3;
	public static final int CHAN_5 = 4;
	public static final int CHAN_6 = 5;
	public static final int CHAN_7 = 6;
	public static final int CHAN_8 = 7;
	public static final int CHAN_9 = 8;
	public static final int CHAN_10 = 9;
	public static final int CHAN_11 = 10;
	public static final int CHAN_12 = 11;
	public static final int CHAN_13 = 12;
	public static final int CHAN_14 = 13;
	public static final int CHAN_15 = 14;
	public static final int CHAN_16 = 15;
}