package MIDICompose;

public class MasterVolume extends SystemExclusive implements Amountable
{
	public static final int MIN = 0;
	public static final int MAX = 0x3fff;
	public static final int ZERO = 0x3fff;

	public static final int DISREGARD = 0x7f;				// to en/dis-able all SysExChannels

	public MasterVolume(int amount) { this(0, DISREGARD, amount); }
	public MasterVolume(int deltaTime, int sysExChannel, int amount) {
		super(deltaTime, SYSEX);
		setDataValueAt(0x7f,0);
		setSysExChannel(sysExChannel);
		setDataValueAt(4,2);
		setDataValueAt(1,3);
		setAmount(amount);
		lock(); }

	public int sysExChannel() { return dataValueAt(1); }
	public void setSysExChannel(int sysExChannel) { setDataValueAt(sysExChannel,1); }

	public int amount() { return (dataValueAt(5) << 7) + dataValueAt(4); }
	public void setAmount(int amount) {
		if((amount < MIN) || (amount > MAX)) {
			System.out.println("ERROR: MasterVolume-amount out of range."); System.exit(-1); }
		setDataValueAt(amount & 0x7f, 4);
		setDataValueAt(amount >> 7, 5); }

	public int minAmount() { return MIN; }
	public int maxAmount() { return MAX; }
	public int zeroAmount() { return ZERO; }

	public MIDIObject copy() {
		return new MasterVolume(deltaTime(), sysExChannel(), amount()); }
}

