package MIDICompose;

import java.io.*;

abstract public class MetaEvent extends MIDIEvent		// this class can only be subclassed
{
	protected MetaEvent(int deltaTime, int type) { super(deltaTime, 0xff); setType(type); }

	protected int type() { return dataValueAt(0); }
	protected void setType(int type) { setDataValueAt(type, 0); }

	protected int dataValueAt(int index) { return super.dataValueAt(index); }
	protected void setDataValueAt(int value,int index) {	// overwritten: values > 127
		if(index >= 0) index++;
		if(size() == index) add(new MIDIByte(value));
		else if(size() > index) ((MIDIByte)elementAt(index)).setValue(value);
		else { System.out.println("ERROR: data-index out of range."); System.exit(-1); }}

	int printSize() {									// returns Bytes needed in MIDI-file
		int size = size() - 2;
		int bytes = 0;
		if(size < 0x80) bytes++;
		else if(size < 0x4000) bytes += 2;
		else if(size < 0x200000) bytes += 3;
		else bytes += 4;
		return bytes + super.printSize(); }

	void print(FileOutputStream fpp) throws IOException {	// overwritten
		printVarLen(fpp, writeTime());
		fpp.write(0xff);
		fpp.write(((MIDIByte)elementAt(1)).value());
		printVarLen(fpp, size() - 2);
		for(int i = 2; i < size(); i++) fpp.write(((MIDIByte)elementAt(i)).value()); }
}
