package MIDICompose;

public class PitchBend extends VoiceEvent implements Channelable, Amountable
{
	public static final int MIN = -8192;
	public static final int MAX = 8191;
	public static final int ZERO = 0;

	public PitchBend(int amount) { this(0, 0, amount); }
	public PitchBend(int deltaTime, int channel, int amount) {
		super(deltaTime, 0xe0, channel); setAmount(amount); lock(); }

	public int amount() { return (dataValueAt(1) << 7) + dataValueAt(0) - 8192; }

	public void setAmount(int amount) {
		if((amount > MAX) || (amount < MIN)) {
			System.out.println("ERROR: PitchBend out of range."); System.exit(-1); }
		amount += 8192;
		setDataValueAt(amount & 0x7f,0);
		setDataValueAt(amount >> 7,1);
	}

	public int minAmount() { return MIN; }
	public int maxAmount() { return MAX; }
	public int zeroAmount() { return ZERO; }

	public MIDIObject copy() { return new PitchBend(deltaTime(), channel(), amount()); }
}
