package MIDICompose;

public class PitchBendRange extends MIDIObject implements Channelable
{
	public PitchBendRange(int semitones) { this(0, 0, semitones, 0); }
	public PitchBendRange(int deltaTime, int channel, int semitones, int cents) {
		this(deltaTime, channel, semitones, cents,
			CombinedControlChange.DATA_ENTRY, CombinedControlChange.DATA_ENTRY + 32); }
	public PitchBendRange(int deltaTime, int channel, int semitones, int cents, int coarse, int fine) {
		super(deltaTime);
		add(new CombinedControlChange(0, channel, CombinedControlChange.REGISTERED_PARAMETER, 0));
		add(new ControlChange(0, channel, coarse, semitones));
		add(new ControlChange(0, channel, fine, cents));
		lock(); }

	public int channel() { return ((Channelable)elementAt(1)).channel(); }
	public void setChannel(int channel) {
		for(int i = 0; i < size(); i++) ((Channelable)elementAt(i)).setChannel(channel); }

	public int semitones() { return ((Amountable)elementAt(1)).amount(); }
	public void setSemitones(int semitones) {
		((Amountable)elementAt(1)).setAmount(semitones); }

	public int cents() { return ((Amountable)elementAt(2)).amount(); }
	public void setCents(int cents) { ((Amountable)elementAt(2)).setAmount(cents); }

	public int coarse() { return ((ControlChange)elementAt(1)).controller(); }
	public void setCoarse(int controller) {
		((ControlChange)elementAt(1)).setController(controller); }

	public int fine() { return ((ControlChange)elementAt(2)).controller(); }
	public void setFine(int controller) {
		((ControlChange)elementAt(2)).setController(controller); }

	public MIDIObject copy() {
		return new PitchBendRange(deltaTime(), channel(), semitones(), cents(), coarse(), fine()); }
}