package MIDICompose;

public class TextMetaEvent extends MetaEvent
{
	public static final int TEXT = 1;
	public static final int COPYRIGHT = 2;
	public static final int TRACK_NAME = 3;
	public static final int INSTRUMENT = 4;
	public static final int LYRIC = 5;
	public static final int MARKER = 6;
	public static final int CUE_POINT = 7;

	public TextMetaEvent(String text) { this(0, TEXT, text); }
	public TextMetaEvent(int deltaTime, int type, String text) {
		super(deltaTime, type); setType(type); setText(text); }

	public int type() { return super.type(); }
	public void setType(int type) {
		if((type >= TEXT) && (type <= CUE_POINT)) super.setType(type);
		else { System.out.println("ERROR: wrong type in TextMetaEvent."); System.exit(-1); }}

	public String text() {
		byte text[] = new byte[size() - 2];
		for(int i = 0; i < (size() - 2); i++) text[i] = (byte)dataValueAt(i+1);
		return new String(text); }
	public void setText(String text) {
		int size = text.length();
		if(size() > size) size = size();
		for(int i = 0; i < size; i++)
			if(i < text.length()) setDataValueAt(text.charAt(i), i+1);
			else setDataValueAt(0, i+1); }

	public MIDIObject copy() { return new TextMetaEvent(deltaTime(), type(), text()); }
}
