package MIDICompose;

public class TimeSignature extends MetaEvent
{
	public TimeSignature(int numerator, int denominator) {
		this(0, numerator, denominator, 24, 24); }
	public TimeSignature(int deltaTime, int numerator, int denominator, int metronome, int clock) {
		super(deltaTime, 0x58);
		setNumerator(numerator);
		setDenominator(denominator);
		setMetronome(metronome);
		setClock(clock);
		lock(); }

	public int metronome() { return dataValueAt(3); }
	public void setMetronome(int metronome) { setDataValueAt(metronome, 3); }
	public int clock() { return dataValueAt(4); }
	public void setClock(int clock) { setDataValueAt(clock, 4); }
	public int numerator() { return dataValueAt(1); }
	public void setNumerator(int numerator) { setDataValueAt(numerator, 1); }
	public int denominator() { return (1 << dataValueAt(2));  }
	public void setDenominator(int denominator) {
		int exp = 0;
		for(int i = 0; i < 6; i++) if((denominator >> i) == 1) exp = i;	// stored as 2exp(den)
		if((1 << exp) != denominator) {
			System.out.println("ERROR: denominator out of range [1|2|4|8|16|32|64].");
			System.exit(-1); }
		setDataValueAt(exp, 2); }

	public MIDIObject copy() {
		return new TimeSignature(deltaTime(), numerator(), denominator(), metronome(), clock()); }
}
